/* 
 * Skyplet - Java Applet for SkyChat project 
 * Copyright (c) 2001,2002 Pawel Prokop (pablo@ae.krakow.pl)
 */

import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;
import java.net.*;
import java.io.*;
import java.util.Date;


/**
 * KLASA WYWOLUJACA SKYCHATA (odpalajaca nowe okno w ktorym bedzie dzialal SkyChat)
 */
 
public class Skyplet extends Applet {
	public Image myIcon_yellow;
//	public Image myIcon_pink;
//	public Image myIcon_green;
//	public Image myIcon_blue;
	
public void init ()	{
	myIcon_yellow = getImage(getCodeBase(),"face_yellow.gif");
//	myIcon_pink = getImage(getCodeBase(),"face_pink.gif");
//	myIcon_green = getImage(getCodeBase(),"face_green.gif");
//	myIcon_blue = getImage(getCodeBase(),"face_blue.gif");

	SkyChat skychat = new SkyChat();
	skychat.setSize(450,350);
	skychat.setResizable(false);
	skychat.setIconImage(myIcon_yellow);
	skychat.show();
	}

}


/**
 * GLOWNA KLASA PROGRAMU, ZAWIERA OKNO GLOWNE Z CZATEM
 */
 
class SkyChat extends Frame implements ActionListener, WindowListener
{
// okno z lista uzytkownikow na danym kanale.
//	static TextArea theUsersWindow = new TextArea("",10,10,TextArea.SCROLLBARS_VERTICAL_ONLY);
	static List theUsersList;
// okno z tekstem.
	static TextArea theTextWindow;
// okno do ktorego wpisuje sie tekst.	
	static private TextField theTextField;
	static private TextField theLoginField;
	static Button theLoginButton;

	private MenuBar myMenuBar = new MenuBar();
	private Menu myMain = new Menu("Main");
	private Menu myOptions = new Menu("Options");
	private Menu generalMenu = new Menu("General");
	private Menu ignoreMenu = new Menu("Ignore");
	private CheckboxMenuItem menuGeneralEnable;
	private CheckboxMenuItem menuGeneralDisable;
	private CheckboxMenuItem menuGeneralInvisible;
	private CheckboxMenuItem menuGeneralBusy;

	private CheckboxMenuItem menuIgnoreAll;
	private CheckboxMenuItem menuIgnoreNone;
	private CheckboxMenuItem menuIgnoreSelected;

	static MyConnection conn = null;
	
	static public String nick = "Anonymous";

	static int state;

	final static int DISCONNECTED=0;
	final static int CONNECTED=1;

	public final static String ID_LOGIN		=	"\0\0\0\0";
	public final static String ID_LOGOUT	=	"\1\0\0\0";
	public final static String ID_PUBLIC	=	"\2\0\0\0";
	public final static String ID_PRIVATE	=	"\4\0\0\0";
	public final static String ID_LISTS		=	"\5\0\0\0";
	public final static String ID_INFO		=	"\10\0\0\0"; // 8
	public final static String ID_STATE		=	"\11\0\0\0"; 

	final static int MAX_USERS_AVAILABLE = 50;
	final static int MAX_NICK_SIZE  = 13;
	final static int MAX_NAME_SIZE  = 64;
	final static int MAX_IPV4_SIZE  = 15;
	static String theServerHost = "149.156.213.7";
	static int theServerPort = 2666;

	static Users users [];
	static public int bla;

// kolory 

	public static Color bgMainColor = new Color (167,204,226);
	public static Color fgMainColor = new Color (2,52,84);
	public static Color bgWindowColor = new Color (204,250,226);
	
	Image myIcon;
/**
 * Konstruktor okna SkyChata
 */
	
public SkyChat()	{  
	setBackground(bgMainColor); // jasny cyjan
	setForeground(fgMainColor); // ciemny granat

	theUsersList = new List(9);
	theUsersList.setBackground(bgWindowColor);
	theUsersList.setForeground(Color.black);
	theTextWindow = new TextArea("",10,50,TextArea.SCROLLBARS_VERTICAL_ONLY);
	theTextWindow.setBackground(bgWindowColor);
	theTextWindow.setForeground(Color.black);
	theTextField = new TextField(70);
	theTextField.setBackground(bgWindowColor);
	theTextField.setForeground(Color.black);
	theLoginField = new TextField(15);
	theLoginField.setBackground(bgWindowColor);
	theLoginField.setForeground(Color.black);
	theLoginField.setText(nick);
	theLoginButton = new Button("Connect");
	theLoginButton.setBackground(fgMainColor);
	theLoginButton.setForeground(bgWindowColor);
	
	System.out.println("SkyChat");
	setTitle("SkyChat");
	addWindowListener(this);

	// rysuje interfejs.
	state = DISCONNECTED;

	/* MENU */
	MenuItem menuGeneralOptions = new MenuItem ("General Options");
	menuGeneralEnable = new CheckboxMenuItem ("Enable", true);
//	menuGeneralEnable.setEnabled(false);
	menuGeneralEnable.addItemListener(new ItemListener() {
		public void itemStateChanged (ItemEvent e)	{
			// trzeba tu jeszcze sprawdzic stan, ale cos sie nie udawalo (SPRAWDZIC POZNIEJ)
			menuGeneralEnable.setState(true);
			menuGeneralDisable.setState(false);
			menuGeneralInvisible.setState(false);
			menuGeneralBusy.setState(false);
			conn.sendString(new String(ID_STATE.concat("\0\0\0\0")));
			// jeszcze musi wyslac do serwera, ze jest enable.
			}
		});
	menuGeneralDisable = new CheckboxMenuItem ("Disable", false);
//	menuGeneralDisable.setEnabled(false);
	menuGeneralDisable.addItemListener(new ItemListener()	{
		public void itemStateChanged (ItemEvent e)	{
			menuGeneralEnable.setState(false);
			menuGeneralDisable.setState(true);
			menuGeneralInvisible.setState(false);
			menuGeneralBusy.setState(false);
			conn.sendString(new String(ID_STATE.concat("\1\0\0\0")));
			// i wyslac do serwera info
			}
		});
		
	menuGeneralInvisible = new CheckboxMenuItem ("Invisible", false);
//	menuGeneralInvisible.setEnabled(false);
	menuGeneralInvisible.addItemListener(new ItemListener ()	{
		public void itemStateChanged (ItemEvent e)	{
			menuGeneralEnable.setState(false);
			menuGeneralDisable.setState(false);
			menuGeneralInvisible.setState(true);
			menuGeneralBusy.setState(false);
			conn.sendString(new String(ID_STATE.concat("\2\0\0\0")));
			// wyslac do serwera
			}
		});
	
	menuGeneralBusy = new CheckboxMenuItem ("Busy", false);
//	menuGeneralBusy.setEnabled(false);
	menuGeneralBusy.addItemListener (new ItemListener ()	{
		public void itemStateChanged (ItemEvent e)	{
			menuGeneralEnable.setState(false);
			menuGeneralDisable.setState(false);
			menuGeneralInvisible.setState(false);
			menuGeneralBusy.setState(true);
			conn.sendString(new String(ID_STATE.concat("\3\0\0\0")));
			// wyslac do serwera
			}
		});

	generalMenu.add(menuGeneralEnable);
	generalMenu.add(menuGeneralDisable);
	generalMenu.add(menuGeneralInvisible);
	generalMenu.add(menuGeneralBusy);
	myOptions.add(generalMenu);

	menuIgnoreNone = new CheckboxMenuItem ("None",false);
	menuIgnoreNone.setEnabled(false);
	menuIgnoreAll = new CheckboxMenuItem ("All",false);
	menuIgnoreAll.setEnabled(false);
	menuIgnoreSelected = new CheckboxMenuItem ("Selected",true);
	menuIgnoreSelected.setEnabled(false);
	
	ignoreMenu.add(menuIgnoreNone);
	ignoreMenu.add(menuIgnoreAll);
	ignoreMenu.add(menuIgnoreSelected);
	myOptions.add(ignoreMenu);
	MenuItem myConnect = new MenuItem ("Connect");
	myConnect.addActionListener (new ActionListener () {
		public void actionPerformed (ActionEvent e)	{
			ConnectWindow theConnectWindow = new ConnectWindow ();
			}
		});	
	MenuItem myClose = new MenuItem ("Exit");
	myClose.addActionListener (new ActionListener ()	{
		public void actionPerformed (ActionEvent e)	{
			hide();
			dispose();
			}
		});
	myMain.add(myConnect);
	myMain.add(myClose);	
	myMenuBar.add(myMain);
	myMenuBar.add(myOptions);
	setMenuBar(myMenuBar);
	/* /MENU */

	users = new Users [MAX_USERS_AVAILABLE];
	for (int i=0;i<MAX_USERS_AVAILABLE;i++)
		users[i] = new Users();

	GridBagLayout theGridBag = new GridBagLayout();
	
	GridBagConstraints theConstraints = new GridBagConstraints ();
	setLayout(theGridBag);

	theConstraints.fill = GridBagConstraints.NONE; // zeby nie wzrastalo
	
	theConstraints.gridwidth = GridBagConstraints.REMAINDER;
	theConstraints.weightx = 1.0;
	Label label=new Label("SkyChat Applet ver 0.1");
	label.setForeground(Color.black);
	theGridBag.setConstraints(label,theConstraints);
	add(label);

	Panel thePanel = new Panel ();
	thePanel.add(theLoginField);
	thePanel.add(theLoginButton);
	theLoginField.addActionListener(new ActionListener (){
		public void actionPerformed(ActionEvent e)	{
			if (state==DISCONNECTED)	{
				nick=theLoginField.getText();
				if (nick.length()==0) nick="Anonymous";
				else if (nick.length()>MAX_NICK_SIZE) nick=nick.substring(0,MAX_NICK_SIZE-1);
				connectToServer();
				}
			}
		});

	theLoginButton.addActionListener(new ActionListener (){
		public void actionPerformed(ActionEvent e)	{
			switch (state)	{
				case DISCONNECTED:
					nick=theLoginField.getText();
					if (nick.length()==0) nick="Anonymous";
					else if (nick.length()>MAX_NICK_SIZE) nick=nick.substring(0,MAX_NICK_SIZE-1);
					connectToServer();
					break;
				case CONNECTED:
					disconnectFromServer();
					theUsersList.removeAll();
					break;
				}
			}
		});

	/* Lista uzytkownikow po prawej stronie */
	theUsersList.addActionListener(new ActionListener (){
		public void actionPerformed(ActionEvent e)	{
			int i;
			String usersNick = theUsersList.getSelectedItem();
			i=findUserIndex(usersNick);
			if (i!=-1)	{ // jesli user juz ma otwarte okno.
				users[i].activateWindow();
				}
			else {
				i=findFirstFree();
				System.out.println("First Free : "+i);
				if (i!=-1) { // jesli jest miejsce na stworzenie nowego okna.
					users[i].createNewWindow(usersNick,i);
					}
				}	
			}
		});
	/* /ListaUzytkownikow */

	
	theConstraints.gridwidth = GridBagConstraints.REMAINDER;
	theConstraints.weightx = 1.0;
	theGridBag.setConstraints(thePanel,theConstraints);
	add(thePanel);

	theConstraints.gridwidth = GridBagConstraints.RELATIVE;
	theConstraints.weightx = 1.0;
	theGridBag.setConstraints(theTextWindow,theConstraints);
	theTextWindow.setEditable(false);
	add(theTextWindow);
	
	theConstraints.gridwidth = GridBagConstraints.REMAINDER;
	theConstraints.weightx = 0.0;
	theGridBag.setConstraints(theUsersList,theConstraints);
	add(theUsersList);

	theConstraints.gridwidth = GridBagConstraints.REMAINDER;
   theConstraints.weightx = 0.0;
   theGridBag.setConstraints(theTextField,theConstraints);
	theTextField.addActionListener(this);
	add(theTextField);

	Label copyLabel = new Label ("Copyright 2001, 2002 Pawel Prokop");
	copyLabel.setForeground(Color.black);
	theConstraints.gridwidth = GridBagConstraints.REMAINDER;
	theConstraints.weightx = 0.0;
	theGridBag.setConstraints(copyLabel,theConstraints);
	add(copyLabel);
	}

/**
 * Funkcje ogolne engine'u SkyChata - wyslanie, odebranie danych, 
 * wyswietlenie w odpowiednich komponentach na ekranie
 */
 
public void dispose ()	{
	if (state==CONNECTED) disconnectFromServer();
	}

static private int connectToServer ()	{
	conn = new MyConnection();
	conn.start();
	return 0;
	}

static private int disconnectFromServer ()	{
// musi wyslac ramke z requestem logouta.
	conn.sendString(ID_LOGOUT);
	conn = null;
	isConnected(false);
	closeAllUsers();
	addToTextWindow("Disconnected from server");
	return 0;
	}




/**
 * METODY OBSLUGUJACE UZYTKOWNIKOW
 */


/**
 * Metoda zwraca indeks aktywnego usera (jego okno jest otwarte)
 */
static private int findUserIndex(String username)	{
	int i=0;
	while (i<MAX_USERS_AVAILABLE)	{
		if ((users[i].nick.compareTo(username)==0)&&(users[i].index!=-1))
			return i; // zwraca jego index
		i++;
		}
	return -1;	// user o podanym nicku nie zostal znaleziony (nie jest aktywne jego okno na ekranie
	} //findUserIndex

/**
 * Metoda zwraca pierwszy wolny indeks w tablicy uzytkownikow
 */
static private int findFirstFree()	{
	int i=0;
	while (i<MAX_USERS_AVAILABLE)	{
		if (users[i].index==-1)
			return i; // zwraca jego index
		i++;	
		}
	return -1; // oznacza, ze nie ma wolnego miejsca dla usera
	}//findFirstFree

/**
 * Metoda zamyka wszystkie okna z uzytkownikami
 */

static private void closeAllUsers ()	{
	for (int i=0;i<MAX_USERS_AVAILABLE;i++)	{
		users[i].close();
		}
	}


/**
 * Metoda rozpakowuje odebrany ciag bitow na odpowiednie struktury
 * podejmuje wlasciwe dzialanie.
 */
 
static synchronized void gotBuf (byte buf [], int ile)	{
	long fid = binaryToLong(new String(buf,0,4));
	int code;
	int i;
	String not;
	String mes;
	
	System.out.println("Function ID="+fid);
	switch ((int)fid)	{
		case 2 : // przyszlo publics
			String b = new String (buf,4,ile-4); // powinno dac sie to samo inaczej
			int index=b.indexOf('\0');
			System.out.println("index = "+index);
			String nic = new String(b.substring(0,index));
			mes = new String ("<".concat(nic).concat("> ").concat(b.substring(MAX_NICK_SIZE)));
			addToTextWindow(mes);
			break;
		case 3 : // notice przyszlo
			System.out.println("notice");
			code = binaryToInt (new String(buf,4,2));
			switch (code)	{
				case 1: // user arrived;
					not = new String(buf,6,ile-6).trim();
					System.out.println(not);
					addToTextWindow(not.concat(" just arrived"));
					theUsersList.add(not);
					break;
				case 2: // user sobie poszedl
					not = new String(buf,6,ile-6).trim();
					System.out.println(not);
					addToTextWindow(not.concat(" went away"));
					theUsersList.remove(not);
					break;
				}
			break;
		case 4 : // przyszlo private message;
			not  = new String (buf, 4,MAX_NICK_SIZE).trim(); /// == from;
			mes = new String (buf,17,ile-17).trim();
			i = findUserIndex(not); // szuka otwartego usera
			if (i!=-1)	{ // czyli okno jest juz otwarte.
				users[i].sendToWindow("\n<".concat(not).concat("> ").concat(mes));
				}
			else	{ // trzeba bedzie otworzyc okno (DOROBIC SPRAWDZANIE ILOSCI OKIEN
				i=findFirstFree();
				if (i!=-1)	{ // czyli jest miejsce na to, zeby otworzyc okno
	            users[i].createNewWindow(not,i);
					users[i].sendToWindow("\n<".concat(not).concat("> ").concat(mes));
					}
				}
			break;
		case 5 : // lista uzytkownikow.
			code = binaryToInt(new String(buf,4,2));
//			System.out.println("lista = " + code);
//			System.out.println(new String (buf,6,60));
			for (i=0;i<code;i++)	{
				not = new String (buf,6+(MAX_NICK_SIZE*i),MAX_NICK_SIZE).trim();
				theUsersList.add(not);
				}
			break;
		case 6 : // error
			code = binaryToInt(new String(buf,4,2));
			System.out.println("code = " + code);
			switch (code)	{
				case 0: // error_ok
					addToTextWindow("Successfully logged into server");
					isConnected(true); // updateuje buttona.
					conn.sendString(ID_LISTS);
					break;
				case 2: // error_login_exist
					addToTextWindow("Connection failed : Login exist");
					isConnected(false); // updateuje buttona.
					break;
				case 4: // error_user_unknown 
					not = new String (buf,6,MAX_NICK_SIZE).trim();
					i = findUserIndex(not);// sprawdza, czy jest jeszcze otwarte okno z mesgiem do usera
					if (i!=-1) users[i].sendToWindow("\nCannot send message : ERROR_USER_UNKNOWN ;-)");
					else addToTextWindow("\nCannot send message to ".concat(not).concat(" ERROR_USER_UNKNOWN ;-)"));
					break;
				}
			break;
		case 8 : // info reply
			not = new String (buf,4,MAX_NICK_SIZE).trim(); // nick
			mes = new String (buf,4+MAX_NICK_SIZE,MAX_NAME_SIZE).trim(); //nazwa
			String ip = new String ("ip address   : ".concat(new String(buf,4+MAX_NICK_SIZE+MAX_NAME_SIZE,MAX_IPV4_SIZE))).trim();
			
//			String tillLogin = MyGetIdleString(new String(buf,4+MAX_NICK_SIZE+MAX_NAME_SIZE+MAX_IPV4_SIZE,4));
//			String tillIdle = MeGetIdleString(new String(buf,8+MAX_NICK_SIZE+MAX_NAME_SIZE+MAX_IPV4_SIZE,4));
			
//			int log = unsignInt(buf[88])+(unsignInt(buf[85])<<8)+(unsignInt(buf[87])<<16)+(unsignInt(buf[86])<<24);
//			int mils = log;
//			System.out.println(unsignInt(buf[82])+" "+unsignInt(buf[83])+" "+unsignInt(buf[84])+" "+unsignInt(buf[85]));
//			Date log_date = new Date ((new Date()).getTime()-(log*1000));
//			log = buf[84]+(buf[83]<<8)+(buf[82]<<16)+(buf[81]<<24);
//			Date idle_date = new Date ((new Date()).getTime()-(log*1000));
			i = findUserIndex(not);

			String czas = new String ("login till : ".concat(MyGetIdleString(new String(buf,4+MAX_NICK_SIZE+MAX_NAME_SIZE+MAX_IPV4_SIZE,4))).concat("\n"));
			String idle = new String ("idle till  : ".concat(MyGetIdleString(new String(buf,8+MAX_NICK_SIZE+MAX_NAME_SIZE+MAX_IPV4_SIZE,4))).concat("\n"));

			if (i!=-1) {
				users[i].sendToWindow(new String("\nuser login   : ".concat(not).concat("\n")));
				users[i].sendToWindow(czas);
				users[i].sendToWindow(idle);
				users[i].sendToWindow(ip);
				}
			else {
				addToTextWindow(czas);
				addToTextWindow(idle);
				addToTextWindow(ip);
				}
			break;
		}
	System.out.println(fid);
	}

private static String MyGetIdleString (String bla)	{
byte [] buf = bla.getBytes();
return longToTime(unsignInt(buf[0])+(unsignInt(buf[1])<<8)+(unsignInt(buf[2])<<16)+(unsignInt(buf[3])<<24));
}

private static int unsignInt (byte bajt)	{
if (bajt<0)	return (256+bajt);
else return bajt;
}


private static String longToTime (int idle)	{
int godziny = idle / 3600;
int minuty = (idle - (godziny * 3600)) / 60;
int sekundy = idle - (godziny * 3600) - (minuty * 60);

String god;
String min;
String sec;

String retval = new String("");
if (godziny<10) god=new String("0".concat(String.valueOf(godziny))).concat(":");
else god=new String(String.valueOf(godziny)).concat(":");

if (minuty<10) min=new String("0".concat(String.valueOf(minuty))).concat(":");
else min=new String(String.valueOf(minuty)).concat(":");

if (sekundy<10) sec=new String("0".concat(String.valueOf(sekundy)));
else sec=new String(String.valueOf(sekundy));
System.out.println(new String(god.concat(min).concat(sec)));
return new String(god.concat(min).concat(sec));
}

private static int binaryToLong (String binary)	{
byte [] buf = binary.getBytes();
return unsignInt(buf[0])+(unsignInt(buf[1])<<8)+(unsignInt(buf[2])<<16)+(unsignInt(buf[3])<<24);
}

private static int binaryToInt (String binary)	{
byte [] buf = binary.getBytes();
return buf[0]+(256*buf[1]);
}

/* metoda modyfikuje wyglad buttona. */
static synchronized void isConnected (boolean is)	{
	if (is) {
		state = CONNECTED;
		theLoginButton.setLabel("Logout");
		}
	else {
		state = DISCONNECTED;
		theLoginButton.setLabel("Login");
		}
	}

public static void setRemoteServer (String hostname, String port, String nickname)	{
Long var = new Long (port);
theServerPort = var.intValue();
theServerHost = hostname;
nick = nickname;
theLoginField.setText(nickname);
if (state==CONNECTED) disconnectFromServer();
connectToServer();
}

public static String getNick () {
return nick;
}


/* metoda dodaje stringa do okna */
static synchronized void addToTextWindow (String str)	{
	theTextWindow.append("\n"+str);
	}

static synchronized void sendPrivateMessage (String to, String mes)	{
String nulls = new String ("\0\0\0\0\0\0\0\0\0\0\0\0\0"); // nulle uzywane, zeby wypelnic nicka
conn.sendString(ID_PRIVATE.concat(to).concat(nulls.substring(to.length())).concat(mes));
}

static synchronized void sendString (String str)	{
conn.sendString(str);
}


public void actionPerformed(ActionEvent e)   {
	if (state==CONNECTED)	{
		theTextWindow.append("\n".concat("<").concat(nick).concat("> ").concat(theTextField.getText()));
		String blah = new String(ID_PUBLIC.concat("             ").concat(theTextField.getText()));
		// System.out.println(blah);
		conn.sendString(blah);
		theTextField.setText("");
		}
   }


/**
 * Funkcje obslugujace Frame'a w ktorym znajduje sie okno glowne SkyChata
 */
 
public void windowOpened (WindowEvent e)	{}
public void windowClosing (WindowEvent e)	{
	hide();
	dispose();
/*	try {
		finalize();
		}
	catch (Throwable bla)	{}	
*/	}
public void windowDeiconified (WindowEvent e) {}
public void windowDeactivated (WindowEvent e) {}
public void windowClosed (WindowEvent e) {}
public void windowIconified (WindowEvent e) {}
public void windowActivated (WindowEvent e) {}
						
} /* Skyplet */





/**
 * Watek odbierajacy i wysylajacy dane od/do serwera
 * Uruchomiony w momencie logowania do serwera
 */
 
class MyConnection extends Thread {
	Socket sock = null;
	public PrintWriter outStream = null;
	DataInputStream inStream = null;
	
	public void run ()	{
	try { // laczy
		sock = new Socket (SkyChat.theServerHost, SkyChat.theServerPort);
		}
	catch (IOException e)	{
		// znaczy sie, ze bylo connection refused...
		SkyChat.addToTextWindow("Connection Refused");
		System.out.println(e.getMessage());
		return;
		}
	
	try	{
		outStream = new PrintWriter(sock.getOutputStream(),true);
		inStream = new DataInputStream(new DataInputStream(sock.getInputStream()));
		
		outStream.write(SkyChat.ID_LOGIN.concat(SkyChat.getNick()));
		outStream.flush();

		byte buf [] = new byte [5000];
		int readed;
		
		while ((readed=inStream.read(buf))!=-1)	{
			SkyChat.gotBuf(buf,readed);
			System.out.println("Readed : " + readed);
			}
			
		inStream.close();
		outStream.close();
		}
	catch (IOException e)	{
		System.out.println("MyConnection " + e.getMessage());
		}
	}

	public void sendString (String str)	{
	outStream.write(str);
	outStream.flush();
	} // run
} // MyConnection





/**
 * Struktura zawierajaca informacje na temat uzytkownika, nazwe,
 * okno w ktorym jest wyswietlany dialog (aktywnego uzytkownika)
 */

class Users {
	public String nick;
	public int index;
	Frame myWindow;
	MenuBar userMenuBar;
	Menu userMenu;
	
	private TextArea userText;
	private TextField myText;

public Users () {
   index=-1;
	nick="";
   }

public void createNewWindow (String usersNick, int i) {
   nick= new String(usersNick);
   index=i;
	
	userMenuBar = new MenuBar();
	userMenu = new Menu("User");
	MenuItem myUserOptions = new MenuItem ("Options");
	userMenu.add(myUserOptions);
	MenuItem myUserInfo = new MenuItem ("Info"); // ma wyswietlic info o gosciu
	myUserInfo.addActionListener(new ActionListener()	{
		public void actionPerformed(ActionEvent e)	{
			SkyChat.sendString(SkyChat.ID_INFO.concat(nick));
			}
		});
	userMenu.add(myUserInfo);
	MenuItem myUserClose = new MenuItem ("Close");
	myUserClose.addActionListener(new ActionListener() {
		public void actionPerformed(ActionEvent e)	{
			close();
			}
		});
	userMenu.add(myUserClose);

	userMenuBar.add(userMenu);
	
	userText  = new TextArea ("",15,80,TextArea.SCROLLBARS_VERTICAL_ONLY);
	myText = new TextField (80);
	myText.setText("");
	userText.setEditable (false);
	
	myWindow = new Frame (usersNick);
	myWindow.setMenuBar(userMenuBar);
	myWindow.setSize(400,300);
	
	GridBagLayout theGridBag = new GridBagLayout();
	GridBagConstraints theConstraints = new GridBagConstraints ();
		 
   myWindow.setLayout(theGridBag);

   theConstraints.fill = GridBagConstraints.NONE; // zeby nie wzrastalo
	
	theConstraints.gridwidth = GridBagConstraints.REMAINDER;
	theConstraints.weightx = 1.0;
	theGridBag.setConstraints(userText,theConstraints);
	myWindow.add(userText);
	
	theConstraints.gridwidth = GridBagConstraints.REMAINDER;
	theConstraints.weightx = 1.0;
	theGridBag.setConstraints(myText,theConstraints);
	myWindow.add(myText);
   
	myWindow.show();

	myText.addActionListener(new ActionListener()	{
		public void actionPerformed(ActionEvent e)	{
			userText.append("\n<".concat(SkyChat.nick).concat("> ").concat(myText.getText()));
			SkyChat.sendPrivateMessage(nick, myText.getText());
			myText.setText("");
			}
		});

   myWindow.addWindowListener(new WindowListener() {
		public void windowOpened (WindowEvent e)  {}
		public void windowClosing (WindowEvent e) {
		   index=-1;
		   nick="";
		   myWindow.hide();
		   myWindow.dispose();
		   }

		public void windowDeiconified (WindowEvent e) {}
		public void windowDeactivated (WindowEvent e) {}
		public void windowClosed (WindowEvent e) {}
		public void windowIconified (WindowEvent e) {}
		public void windowActivated (WindowEvent e) {}
	});

   }

public void sendToWindow(String str)	{
	userText.append(str);
	}

public void activateWindow () {
   }

public void close () {
   if (index!=-1) {
	   index=-1;
		nick="";
  		myWindow.hide();
		myWindow.dispose();
  		}
   }
}




class ConnectWindow	{
Frame myWindow;
TextField theUserText;
TextField theServerText;
TextField thePortText;

ConnectWindow	()	{
	Label theServerLabel = new Label ("Server name");
	Label thePortLabel = new Label ("Port number");
	Label theUserLabel = new Label ("Nickname");
	theServerText = new TextField(20);
	theServerText.setBackground(SkyChat.bgWindowColor);
	theServerText.setForeground(Color.black);
	theServerText.setText(SkyChat.theServerHost);
	thePortText = new TextField(5);
	thePortText.setBackground(SkyChat.bgWindowColor);
	thePortText.setForeground(Color.black);
	thePortText.setText(""+SkyChat.theServerPort);
	theUserText = new TextField(20);
	theUserText.setBackground(SkyChat.bgWindowColor);
	theUserText.setForeground(Color.black);
	theUserText.setText(SkyChat.getNick());
	Button theOK = new Button("OK");
	theOK.setBackground(SkyChat.fgMainColor);
	theOK.setForeground(SkyChat.bgMainColor);
	theOK.addActionListener(new ActionListener () {
		public void actionPerformed(ActionEvent e)	{
			SkyChat.setRemoteServer(theServerText.getText(), thePortText.getText(), theUserText.getText());
			myWindow.hide();
			myWindow.dispose();
			}
		});
	
	Button theCancel = new Button("Cancel");
	theCancel.setBackground(SkyChat.fgMainColor);
	theCancel.setForeground(SkyChat.bgMainColor);
	theCancel.addActionListener(new ActionListener () {
		public void actionPerformed(ActionEvent e)	{
			myWindow.hide();
			myWindow.dispose();
			}
		});
		
	Panel thePanel = new Panel ();

	myWindow = new Frame ("Connection");
   myWindow.setSize(300,200);
	myWindow.setBackground(SkyChat.bgMainColor);
	myWindow.setForeground(SkyChat.fgMainColor);
	
	GridBagLayout theGridBag = new GridBagLayout();
	GridBagConstraints theConstraints = new GridBagConstraints ();

	myWindow.setLayout(theGridBag);

	thePanel.add(theOK);
	thePanel.add(theCancel);

	theConstraints.fill = GridBagConstraints.NONE; // zeby nie wzrastalo
	
	theConstraints.gridwidth = GridBagConstraints.RELATIVE;
	theConstraints.weightx = 1.0;
	theConstraints.anchor = GridBagConstraints.WEST;
	theGridBag.setConstraints(theUserLabel,theConstraints);
	myWindow.add(theUserLabel);

	theConstraints.gridwidth = GridBagConstraints.REMAINDER;
	theConstraints.weightx = 1.0;
	theGridBag.setConstraints(theUserText,theConstraints);
	myWindow.add(theUserText);

	theConstraints.gridwidth = GridBagConstraints.RELATIVE;
	theConstraints.weightx = 1.0;
	theConstraints.anchor = GridBagConstraints.WEST;
	theGridBag.setConstraints(theServerLabel,theConstraints);
	myWindow.add(theServerLabel);

	theConstraints.gridwidth = GridBagConstraints.REMAINDER;
	theConstraints.weightx = 1.0;
	theGridBag.setConstraints(theServerText,theConstraints);
	myWindow.add(theServerText);
									
	theConstraints.gridwidth = GridBagConstraints.RELATIVE;
	theConstraints.weightx = 1.0;
	theGridBag.setConstraints(thePortLabel,theConstraints);
	myWindow.add(thePortLabel);

	theConstraints.gridwidth = GridBagConstraints.REMAINDER;
	theConstraints.weightx = 1.0;
	theGridBag.setConstraints(thePortText,theConstraints);
	myWindow.add(thePortText);

	theConstraints.gridwidth = GridBagConstraints.REMAINDER;
	theConstraints.weightx = 1.0;
	theConstraints.anchor = GridBagConstraints.CENTER;
	theGridBag.setConstraints(thePanel,theConstraints);
	myWindow.add(thePanel);

   myWindow.addWindowListener(new WindowListener() {
		public void windowOpened (WindowEvent e)  {}
		public void windowClosing (WindowEvent e) {
		   myWindow.hide();
		   myWindow.dispose();
		   }

		public void windowDeiconified (WindowEvent e) {}
		public void windowDeactivated (WindowEvent e) {}
		public void windowClosed (WindowEvent e) {}
		public void windowIconified (WindowEvent e) {}
		public void windowActivated (WindowEvent e) {}
	});

	myWindow.show();

   }
}



/**
 * KLASA BEDACA STRUKTURA ZAWIERAJACA OGOLNE OPCJE DLA APLETU
 */

class Options {
	int ignored;
	int ignoreMode;
	int myOptions;

	// ignored
	static final int IGNORE_NONE = 0; // akceptuje wszystkie wiadomosci prywatne
	static final int IGNORE_ALL = 1;  // odrzuca wszystkie wiadomosci prywatne
	static final int IGNORE_INDIVIDUAL = 2; // odrzuca wiadomosci prywatne indywidualnych osob
	static final int IGNORE_ALL_BUT_SELECTED = 3; // odrzuca wszystko oprocz wybranych (invert list)

	// ignoredMode
	static final int IGNORE_MODE_SILENT = 0; // ciche ignorowanie
	static final int IGNORE_MODE_LOUD = 1;   // odsyla komunikat o ignorowaniu prywatnych wiadomosci.

	// myOptions
	static final int USER_ENABLE = 0;  // uzytkownik jest widoczny, dostepny dla wszystkich (chyba, ze ktos ma ignore'a)
	static final int USER_DISABLE = 1; // uzytkownik jest niewidoczny i niedostepny (zgaszony na liscie ?)
	static final int USER_INVISIBLE = 2; // uzytkownik jest niewidoczny
	static final int USER_BUSY = 3; // jest aktywny, przy mesgach odsyla info o tym, ze zajety

/**
 * Konstruktor, generalnie ma odczytywac opcje z pliku
 * poki co to ustawia defaultowe opcje
 */
 
	public Options ()	{
		ignored = IGNORE_NONE;
		ignoreMode = IGNORE_MODE_LOUD;
		myOptions = USER_ENABLE;
		}
/**
 * Metody obslugujace status ignorowania
 */

 // ignoruje wszystko
	public void ignoreAllMessages ()	{
		ignored = IGNORE_ALL;
		}
 
 // nic nie ignoruje
	public void ignoreNoneMessages () {
		ignored = IGNORE_NONE;
		}

 // ignoruje indywidualnych uzytkownikow
	public void ignoreIndividual ()	{
		ignored = IGNORE_INDIVIDUAL;
		}

	public void ignoreAllButSelected ()	{
		ignored = IGNORE_ALL_BUT_SELECTED;
		}

	public boolean isIgnored (String name)	{
		return true;
		}
	
	}


